#include <pards/Sync.h>

int main(int argc, char* argv[])
{

  void foo(Sync<int>*);

  if(argc < 2) {fprintf(stderr,"overhead count\n"); return 0;}
  int count = atoi(argv[1]);
  
  pards_init();

  int res = 0;

  try{
    Sync<int> *a;
    for(int i = 0; i < count; i++){
      a = new Sync<int>;
      SPAWN(foo(a));
      //foo(a);
      res += a->read();
      delete a;
    }
  } catch (PardsException) {
    fprintf(stderr,"exception caught\n");
  }
  
  printf("value = %d\n",res);
  pards_finalize();
}

void foo(Sync<int>* a)
{
  a->write(1);
}
